@echo off
setlocal EnableDelayedExpansion

rem Scroll the screen contents via standard navigation keys
rem Antonio Perez Ayala

rem Define auxiliary values
set /A HomeKey=292, PageUp=289, UpArrow=294, DownArrow=296, PageDown=290, EndKey=291
set /A LeftArrow=293, RightArrow=295, Shift=256,  EnterKey=13
set /A WM_VSCROLL=277, WM_HSCROLL=276, SB_TOP=6, SB_PAGEUP=2, SB_LINEUP=0, SB_LINEDOWN=1, SB_PAGEDOWN=3, SB_BOTTOM=7

rem Define actions per key
set /A vscrl[%HomeKey%]=SB_TOP, vscrl[%PageUp%]=SB_PAGEUP, vscrl[%UpArrow%]=SB_LINEUP
set /A vscrl[%DownArrow%]=SB_LINEDOWN, vscrl[%PageDown%]=SB_PAGEDOWN, vscrl[%EndKey%]=SB_BOTTOM
set /A Shift_LeftArrow=Shift+LeftArrow, Shift_RightArrow=Shift+RightArrow
set /A hscrl[%Shift_LeftArrow%]=SB_PAGEUP, hscrl[%LeftArrow%]=SB_LINEUP
set /A hscrl[%RightArrow%]=SB_LINEDOWN, hscrl[%Shift_RightArrow%]=SB_PAGEDOWN

echo You may scroll the screen contents with standard navigation keys now
set /P "=Press Enter key to exit from scroll mode..." < NUL

:getKey
GetInput
(      if defined vscrl[%errorlevel%] (SendMessage %WM_VSCROLL% !vscrl[%errorlevel%]!
) else if defined hscrl[%errorlevel%]  SendMessage %WM_HSCROLL% !hscrl[%errorlevel%]!
if %errorlevel% neq %EnterKey% goto getKey
)
echo/
